
with Open_Image.Greyscale_Image; use Open_Image.Greyscale_Image;
with Open_Image; use Open_Image;

package body utils is


   -- Modifie l'image pour avoir un contraste Max

   procedure MaxContrast(Img: in out Unbounded_Image)  is
      MaxValue,tmpValue : pixel_value_type :=0;
      Minvalue : Pixel_Value_Type := 255;
  begin
     -- Calcule le max utilise et le min utilis pour toute l'image
     for I in 1..rows(Img) loop
        for J in 1..Columns(Img) loop
           Tmpvalue := Get_Pixel(Img,J,I);
           if Tmpvalue >= Maxvalue then
              Maxvalue := Tmpvalue ;
           end if;
           if Tmpvalue <Minvalue then
              Minvalue := Tmpvalue;
           end if;
        end loop;
     end loop;

     -- Normalisation des couleurs en fonction des bornes
     if Maxvalue = 255 and Minvalue = 0 then
        return; -- rien  faire
     end if;

     if Minvalue = Maxvalue then
        return ; -- rien   faire, l'image est homogne
     end if;

     -- Calcule le max utilise et le min utilis
     for I in 1..Rows(Img) loop
        for J in 1..Columns(Img) loop
           Tmpvalue := Get_Pixel(Img,J,I);
           Tmpvalue := pixel_value_type(Float((Tmpvalue-Minvalue))/(float(Maxvalue-Minvalue))*255.0);
           Set_Pixel(Img,J,I,Tmpvalue);
        end loop;
     end loop;
  end;

   function "*"(Left: in Unbounded_Image;Right : Natural) return Unbounded_Image is
      TempImg : Unbounded_Image;
      Pxv:Pixel_Value_Type;
   begin
      Set_Size(TempImg,Columns(Left),Rows(Left));
      for I in 1..Columns(Left) loop
         for J in 1..Rows(Left) loop
            Pxv := Get_Pixel(Left,I,J);
            if natural(Pxv)*Right> 255 then
               Set_Pixel(tempimg,I,J,255);
            else
               Set_Pixel(tempimg,I,J,Pxv*Pixel_Value_Type(Right));
            end if;
         end loop;
      end loop;
      return Tempimg;
   end;

   procedure Set_Pixel_Unbounded(M : in out Unbounded_image ; X,Y:in Integer; Value : in pixel_value_type) is
   begin
      if X>=1 and X<=Integer(Columns(M)) then
         if Y>=1 and Y<=Integer(Rows(M)) then
            Set_Pixel(M,Column_Index_Type(X),Row_Index_Type(Y),value);

         end if;
      end if;
   end;

   function Get_Pixel_unbounded(Img:in Unbounded_Image;X,Y: in Integer ;Default:in Pixel_Value_Type) return Pixel_Value_Type is
    RetVal : pixel_value_type := default;
   begin
      if X>=1 and X<=Integer(Columns(Img)) then
         if Y>=1 and Y<=Integer(rows(Img)) then
            Retval := Get_Pixel(Img,Column_Index_Type(X),Row_Index_Type(Y));
         end if;
      end if;
      return Retval;
   end;


end utils;
